unit Unit2;

interface

uses System.SysUtils, System.Classes;

type
  TNotifyProcedure = procedure(Status: String; Msg: String) of object;

  TProceThread = Class(TThread)
  private
    FCount: Integer;
    FNotifyProcedure: TNotifyProcedure;
    procedure Execute; override;
  public
    constructor Create(NotifyProcedure: TNotifyProcedure = nil);
    destructor Destroy; override;
  end;

implementation

constructor TProceThread.Create(NotifyProcedure: TNotifyProcedure = nil);
begin
  FCount := 0;
  FNotifyProcedure := NotifyProcedure;
  inherited Create(False);
end;

destructor TProceThread.Destroy;
begin
  inherited;
end;

procedure TProceThread.Execute;
begin
  inherited;
  while not Terminated do begin
    Inc(FCount);
    Synchronize(procedure
      begin
        if Assigned(FNotifyProcedure) then FNotifyProcedure(IntToStr(Fcount), '');
      end);
      Sleep(500);
  end;
end;

end.
